%% Text: Digital Signal Processing in Modern Communication Systems (Edition 2)
%% Chapter 5 - Section 2:  Show Different versions of the Raised Cosing Shape
%% Copyright: Andreas Schwarzinger March 2015
%%
%% Author: Andreas Schwarzinger                          Date: March 2015

clc;            % clear the command line
clear all;      % clear memory
close all;      % close all previously opened figures

Alpha = 0.5;

%% Configuration 1   -- GetRaisedCosine(alpha, N, Oversampling)

[h1, t1] = GetRaisedCosine(0,     69, 8, 0);
[h2, t2] = GetRaisedCosine(0.5,   69, 8, 0);
[h3, t3] = GetRaisedCosine(1.0,   69, 8, 0);  % I include this one only to display
                                              % the quasi continous raised cosine
                                              % shape that I show as dashed
                                              % lines in the plot
                                              
figure(1);
plot(t1, h1, 'k'); grid on; hold on; title('Truncated Raised Cosine Pulse Shapes');
plot(t2, h2, 'k--', 'LineWidth' , 2);
plot(t3, h3, 'k', 'LineWidth', 2);
legend('Alpha = 0.0','Alpha = 0.5', 'Alpha = 1.0');
axis([-4 4 -.3 1]); xlabel('t/Tsymbol');
set(gca, 'XTick', [-3 -2 -1 0 1 2 3 ]);
set(gca, 'YTick', [0 0.5]);

[h1, t1] = GetRaisedCosine(0.0001,     69, 8, 1);
[h2, t2] = GetRaisedCosine(0.5,   69, 8, 1);
[h3, t3] = GetRaisedCosine(1.0,   69, 8, 1);  % I include this one only to display
                                              % the quasi continous raised cosine
                                              % shape that I show as dashed
                                              % lines in the plot

figure(2);
plot(t1, h1, 'k'); grid on; hold on; title('Truncated Root Raised Cosine Pulse Shapes');
plot(t2, h2, 'k--', 'LineWidth' , 2);
plot(t3, h3, 'k', 'LineWidth', 2);
legend('Alpha = 0.0','Alpha = 0.5', 'Alpha = 1.0');
axis([-4 4 -.3 1]); xlabel('t/Tsymbol');
set(gca, 'XTick', [-3 -2 -1 0 1 2 3 ]);
set(gca, 'YTick', [0 0.5]);