%% Text: Digital Signal Processing in Modern Communication Systems (Edition 2)
%% Chapter 5 - Section 2:  Calculating the Discrete Impulse Response of 
%%                         a Raised Cosine Pulse Shaping Filter
%% Copyright: Andreas Schwarzinger March 2015
%%
%% Author: Andreas Schwarzinger                          Date: March 2015

clc;             % clear the command line
clear variables; % clear memory
close all;       % close all previously opened figures

Fs    = 1;    % Symbol Rate
Alpha = 0.5;

%% Configuration 1   -- GetRaisedCosine(alpha, N, Oversampling)
OSR1 = 2;
OSR2 = 4;

[h1, t1] = GetRaisedCosine(Alpha, 15, OSR1, 0);
[h2, t2] = GetRaisedCosine(Alpha, 31, OSR2, 0);
[h3, t3] = GetRaisedCosine(Alpha, 61, OSR2*2, 0);

figure(1);
subplot(1,2,1);
stem(t1, h1, 'k'); grid off; hold on;
plot(t3, h3, 'k--'); 
title('RC Impulse Response (OSR= 2, N = 15)'); xlabel('t/TSymbol');
set(gca, 'XTick', [-3 -2 -1 0 1 2 3]);
subplot(1,2,2);
stem(t2, h2, 'k'); grid off; hold on;
plot(t3, h3, 'k--');
title('RC Impulse Response (OSR= 4, N = 31)'); xlabel('t/TSymbol');
set(gca, 'XTick', [-3 -2 -1 0 1 2 3]);