%% Text: Digital Signal Processing in Modern Communication Systems (Edition 2)
%% Chapter 5 - Section 2:  TX_Waveform_Mapping Test bench
%% Copyright: Andreas Schwarzinger March 2015
%%
%% Author: Andreas Schwarzinger                          Date: March 2015

%% Configuring the Symbol Mapping Process
InputBits  = round(rand(1,2000));
Differential_Flag = 0;  % 0/1 - Absolute Value/Differential Mode
ModulationFormat  = 3; 
    % Differential Mode:   0/1/2   - pi/4-QPSK / D8PSK / pi/8 - D8PSK
    % Absolute Value Mode: 0/1/2/3 - BPSK / QPSK / 8PSK / 16QAM 
    
if(Differential_Flag == 1)
 [SymbolStream] = Differential_Symbol_Mapper(InputBits, ModulationFormat);
else
 [SymbolStream] = Symbol_Mapper(InputBits, ModulationFormat);
end
 
%% Configuring the TX Waveform Mapping Process
N          = 25;
OSR        = 4;
Alpha      = 0.8;    %% Roll-off Factor
Root       = 0;      %% Boolean value 0/1 - RC / RRC
Hann_Flag  = 0;      %% Boolean value 0/1 - Skip / Use Hanning Window
Hann_Index = 1;      %% The index modifies the Hanning Window
 
[SampleStream, Zero_Stuffed, h] = TX_Waveform_Mapping(SymbolStream, N,...
                         OSR, Alpha, Root, Hann_Flag, Hann_Index);

                     
figure(1)
subplot(2,2,1)
stem(real(SampleStream(1, 1:120)), 'k'); grid on;
title('I Sample Stream');
subplot(2,2,3)
stem(real(SampleStream(1, 1:120)), 'k'); grid on;
title('Q Sample Stream');
subplot(2,2,[2,4])
plot(real(SampleStream), imag(SampleStream), 'k'); grid on; hold on;
title('Constellation Diagram with Actual Signal Traces');