%% Text: Digital Signal Processing in Modern Communication Systems (Edition 2)
%% Chapter 7 - Section 5: This code computes the primary synchonization Signal Sequence
%% Copyright: Andreas Schwarzinger May 2021

function d = GeneratePSS_Sequence(PCI)

%% Step 0: Figure out N1 and N2
N1 = floor(PCI/3);
N2 = PCI - 3*N1;

switch(N2)       % See table 6.11.1.1-1
    case 0;  u = 25;
    case 1;  u = 29;
    case 2;  u = 34;
end

d = zeros(1,62);
% Generate first portion from n = 0:30
n = 0:1:30;
d(1,n+1) = exp(-1j*pi*u*n.*(n+1)/63);

% Generate second portion from n = 31:61
n = 31:1:61;
d(1,n+1) = exp(-1j*pi*u*(n+1).*(n+2)/63);
